package org.jeecg.modules.ctop.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.jeecg.modules.ctop.entity.Advertiser;
import org.jeecg.modules.ctop.mapper.AdvertiserMapper;
import org.jeecg.modules.ctop.service.IAdvertiserService;
import org.jeecg.modules.ctop.vo.SheetInfoVo;
import org.jeecg.modules.excelutil.entity.KuaishouXxlEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description: 广告主信息表
 * @Author: jeecg-boot
 * @Date:   2019-06-11
 * @Version: V1.0
 */
@Service
public class AdvertiserServiceImpl extends ServiceImpl<AdvertiserMapper, Advertiser> implements IAdvertiserService {

    @Autowired
    private AdvertiserMapper advertiserMapper;
    @Override
    public List<Advertiser> getBySaleId(String saleId) {
        QueryWrapper<Advertiser> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("sale_id", saleId);
        return this.list(queryWrapper);
    }

    @Override
    public SheetInfoVo getXxlStatisticInfo(Long projectId, String systemType, Long accountId, String groupBy, String sheetName) {
        SheetInfoVo vo = new SheetInfoVo();
        List<KuaishouXxlEntity> details = new ArrayList<>();
        vo.setSheetName(sheetName);
        List<KuaishouXxlEntity> totalList = advertiserMapper.getXXlStatisticInfo(projectId, systemType, accountId, null);
        KuaishouXxlEntity totalEntity = totalList.get(0);
        totalEntity.setDate("汇总");
        details.add(totalEntity);
        details.addAll(advertiserMapper.getXXlStatisticInfo(projectId, systemType, accountId, "state_date"));
        vo.setDetails(details);
        return vo;
    }
}
